clear all;
close all;
clc;

tol = 1e-12;

for n=4:20;

    A = rand(n,2);
    b = rand(n,1);

    x_chol = leastSquares(A,b,'cholesky');
    x_qr = leastSquares(A,b,'qr');
    x_myqr = leastSquares(A,b,'myqr');
    x = A\b;
    
    err_chol = max(abs(x-x_chol));
    err_qr = max(abs(x-x_chol));
    err_myqr = max(abs(x-x_chol));
    
    fprintf('Testcase %d: \n',n-3)
    if err_chol < tol
        fprintf('\t "cholesky": Passed.\n') 
    else
        fprintf(2,'\t "cholesky": Failed.\n') 
    end
    if err_qr < tol
        fprintf('\t "qr": Passed.\n') 
    else
        fprintf(2,'\t "qr": Failed.\n') 
    end
    if err_myqr < tol
        fprintf('\t "myqr": Passed.\n') 
    else
        fprintf(2,'\t "myqr": Failed.\n') 
    end    
    
end
